package com.olopezagu.smartlist.pantalles;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.EditText;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.TextView;

import com.google.zxing.integration.android.IntentIntegrator;
import com.google.zxing.integration.android.IntentResult;
import com.olopezagu.smartlist.R;
import com.olopezagu.smartlist.dades.LiniaLlista;
import com.olopezagu.smartlist.dades.Llista;
import com.olopezagu.smartlist.dades.Producte;
import com.olopezagu.smartlist.dades.Usuari;
import com.olopezagu.smartlist.pantalles.LlistaDetallUtils.elementLlistaDetallAdapter;
import com.olopezagu.smartlist.utils.PantallaSmartList;
import com.olopezagu.smartlist.utils.RestManager;
import com.olopezagu.smartlist.utils.UsuariManager;
import com.olopezagu.smartlist.utils.Utils;
import com.olopezagu.smartlist.utils.finestraConfirmacioOnClick;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.UUID;

/**
 *
 * Pantalla de Llista detall de la aplicació
 *
 * Created by oscar on 17/05/14.
 */
public class LlistaDetall  extends PantallaSmartList
{
    Llista llista;
    ArrayList<LiniaLlista> liniesLlista;
    elementLlistaDetallAdapter contingut;


    @Override
    protected void onInicialitza(Bundle _savedInstance)
    {
        Bundle parametresRebuts = getIntent().getExtras();
        this.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);

        if( parametresRebuts.getInt("accio")==Llistes.CODISLLISTA.NOVA_LLISTA)
        {
            llista = new Llista();
            llista.nom = getResources().getString(R.string.llista_detall_nova_llista);
            llista.idusuari= UsuariManager.getInstance().getIdUsuari();
            llista.save();
        }
        else
        {
            String idLLista = "";
            if(parametresRebuts != null)
            {
                idLLista = parametresRebuts.getString("idllista");
            }


            List<Llista> llistat =  Llista.find(Llista.class, "idllista = ?", idLLista);
            if(llistat.size() ==0)
            {
                llista = new Llista();
                llista.nom = getResources().getString(R.string.llista_detall_nova_llista);
                llista.idusuari= UsuariManager.getInstance().getIdUsuari();
                llista.save();
            }
            else
            {
                llista = llistat.get(0);
                Log.w("Info - ", "Llistat: "+llista.idllista );
                //Utils.missatgeContextual(this, "Llistat: "+llista.idllista);
            }
        }

        if(RestManager.getInstance().managerEnExecucio())
        {
            RestManager.getInstance().eventFi = new Handler(){
                @Override
                public void handleMessage(Message msg)
                {
                    ompleLlista();
                    Utils.tancaDialog();
                }
            };
            Utils.mostraDialog(this,R.string.lldet_actualitza_titol,R.string.lldet_actualitza_missatge);
        }

        ompleLlista();
        setEventOnClickLlista();
    }

    /**
     * Métode per omplir la llista
     */
    private void ompleLlista()
    {
       ListView llistaView = ((ListView) findViewById(R.id.ldetall_lstLlista));
       ((EditText) findViewById(R.id.ldetall_txtNomLlista)).setText(llista.nom);

        if(llista.idllista != null && llista.idllista != "")
        {
            liniesLlista = (ArrayList) LiniaLlista.getLlistat(llista.idllista);

            contingut = new elementLlistaDetallAdapter(this, liniesLlista);

           llistaView.setAdapter(contingut);
           registerForContextMenu(llistaView);
        }
        ((TextView)findViewById(R.id.ldetall_lblTotalR)).setText(Float.toString(contingut.getComprat())+" €");
        ((TextView)findViewById(R.id.ldetall_lblCompratR)).setText(Integer.toString(contingut.getNumElementsComprat()));
    }

    @Override
    protected int getLayoutResourceId()
    {
        return R.layout.llista_detall;
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data)
    {
        super.onActivityResult(requestCode, resultCode, data);

        // Codi per tractar la informació rebuda al escanejar el producte
        IntentResult scanningResult = IntentIntegrator.parseActivityResult(requestCode, resultCode, data);
        if (scanningResult != null) {
         nouProducteCodiBarres(scanningResult.getContents());
        }
        else
        {
            ompleLlista();
        }
    }

    private void nouProducteCodiBarres(String sCodiBarres)
    {
        Producte tProducte = Producte.getProducteCodiBarres(sCodiBarres);
        LiniaLlista tLiniaLlista =LiniaLlista.getLiniaLlistaProducteActual(llista.idllista,tProducte);


        if(tLiniaLlista.idliniallista == null || tLiniaLlista.idliniallista == "")
        {
            tLiniaLlista.idliniallista = UUID.randomUUID().toString().toUpperCase();
            tLiniaLlista.save();

            Intent intent = new Intent(LlistaDetall.this, NouProducte.class);
            intent.putExtra("accio", CODISLLISTADETALLS.ACTUALITZA_PRODUCTE_LLISTA);
            intent.putExtra("idllista", llista.idllista);
            intent.putExtra("idliniallista",tLiniaLlista.idliniallista);
            intent.putExtra("idproducte",tLiniaLlista.getProducte().idproducte);
            startActivityForResult(intent, CODISLLISTADETALLS.ACTUALITZA_PRODUCTE_LLISTA);
        }
        else
        {
            tLiniaLlista.comprat=1;
            tLiniaLlista.guarda();

            ompleLlista();
        }
    }

@Override
public void onBackPressed()
{
    guardaLlista();
    super.onBackPressed();
}

    private void guardaLlista()
    {
        llista.nom=((EditText)findViewById(R.id.ldetall_txtNomLlista)).getText().toString();
        llista.guarda();
    }

    /// EVENTS DE BOTONS

    /**
     * Marca com comprat o no el producte de la llista
     * @param view
     */
    public void btnSelecciona_Click(View view)
    {
        ListView lstLlista = (ListView) findViewById(R.id.ldetall_lstLlista);
        int iPosition = lstLlista.getPositionForView((View) view.getParent());
        LiniaLlista tLiniaLlista = (LiniaLlista) contingut.getItem(iPosition);
        tLiniaLlista.comprat = 1-tLiniaLlista.comprat;

        if(tLiniaLlista.comprat==1)
        {
            tLiniaLlista.datacompra = new Date();
        } else
        {
            tLiniaLlista.datacompra = Utils.dataNull();
        }

        tLiniaLlista.guarda();
        ompleLlista();
    }


    /**
     * Mostra el llistat de productes prèviament insertat
     * @param view
     */
    public void btnLlistatProductes_Click(View view)
    {
        guardaLlista();

        Intent intent = new Intent(LlistaDetall.this, Productes.class);
        intent.putExtra("idllista", llista.idllista);
        intent.putExtra("accio", CODISLLISTADETALLS.INSERTA_PRODUCTE_EXISTENT);
        startActivityForResult(intent, CODISLLISTADETALLS.INSERTA_PRODUCTE_EXISTENT);
    }



    /**
     * Afegeix un nou producte a la llista
     * @param view
     */
    public void btnAfegirProducte_Click(View view)
    {
        guardaLlista();

        Intent intent = new Intent(LlistaDetall.this, NouProducte.class);
        intent.putExtra("idllista", llista.idllista);
        intent.putExtra("accio", CODISLLISTADETALLS.NOU_PRODUCTE_LLISTA);
        startActivityForResult(intent, CODISLLISTADETALLS.NOU_PRODUCTE_LLISTA);
    }

    /**
     * Esborra el producte seleccionat
     * @param view Vista del producte marcat
     */
    public void btnEsborraProducte_Click(View view)
    {
        ListView lstLlista = (ListView) findViewById(R.id.ldetall_lstLlista);
        int iPosition = lstLlista.getPositionForView((View) view.getParent());
        LiniaLlista tLiniaLlista = (LiniaLlista) contingut.getItem(iPosition);

        //Utils.missatgeContextual(Utils.appContext, "Esborra: " + tLiniaLlista.nom);

        Utils.mostraConfirmacio(this, R.string.lldet_esborra_titol, R.string.lldet_esborra_missatge, new finestraConfirmacioOnClick(new Object[]{tLiniaLlista} ) {

            @Override
            public void click(DialogInterface dialogInterface, int i, Object[] parametres)
            {
                LiniaLlista tLiniaLlista = (LiniaLlista)parametres[0];

                tLiniaLlista.esborra();
                ompleLlista();
            }
        }, null);
    }

    /**
     * Event del botó per escanejar un producte
     * @param view
     */
    public void btnScan_Click(View view)
    {
        IntentIntegrator scanIntegrator = new IntentIntegrator(this);
        scanIntegrator.initiateScan();
    }

    /**
     * Estableix els events de la llista al fer click
     */
    private void setEventOnClickLlista()
    {
        ListView lstLlista = (ListView) findViewById(R.id.ldetall_lstLlista);

        // OnClick a la llista
        lstLlista.setOnItemClickListener(new AdapterView.OnItemClickListener()
        {
            @Override
            public void onItemClick(AdapterView<?> adapterView, View view, int i, long l)
            {
                //Utils.missatgeContextual(getBaseContext(), "Seleccionat: " + i);
                ListAdapter la =(ListAdapter) adapterView.getAdapter();

                LiniaLlista tLiniaLlista = (LiniaLlista)la.getItem(i);

                Intent intent = new Intent(LlistaDetall.this, NouProducte.class);
                intent.putExtra("accio", CODISLLISTADETALLS.ACTUALITZA_PRODUCTE_LLISTA);
                intent.putExtra("idllista", llista.idllista);
                intent.putExtra("idliniallista",tLiniaLlista.idliniallista);
                intent.putExtra("idproducte",tLiniaLlista.getProducte().idproducte);
                startActivityForResult(intent, CODISLLISTADETALLS.ACTUALITZA_PRODUCTE_LLISTA);
            }
        });

        // OnClick llarg a la llista
        // lstLlista.setOnItemLongClickListener();
    }


    // -------------------------------


    public static class CODISLLISTADETALLS
    {
      public static final int ERROR=0x0;
      public static final int NOU_PRODUCTE=0x1;
      public static final int ACTUALITZA_PRODUCTE=0x2;
      public static final int NOU_PRODUCTE_LLISTA =0x4;
      public static final int ACTUALITZA_PRODUCTE_LLISTA =0x8;
      public static final int INSERTA_PRODUCTE_EXISTENT =0x16;

    }
}
