package com.olopezagu.smartlist.pantalles.LlistaDetallUtils;

import android.content.Context;
import android.graphics.Paint;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.olopezagu.smartlist.R;
import com.olopezagu.smartlist.dades.LiniaLlista;

import java.util.ArrayList;

/**
 * Aquesta clase és la base de cada element del llistat de linies de compra de la aplicació.
 *
 *
 * Created by oscar on 17/05/14.
 */
public class elementLlistaDetallAdapter extends BaseAdapter
{
    private ArrayList<LiniaLlista> liniallistes;
    private LayoutInflater lInflater;

    public elementLlistaDetallAdapter(Context _ctx, ArrayList<LiniaLlista> _liniallistes)
    {
        this.lInflater= LayoutInflater.from(_ctx);
        this.liniallistes=_liniallistes;
    }


    public int getNumElementsComprat()
    {
        int iTotal=0;

        for(int i=0;i<liniallistes.size();i++)
        {
            if(liniallistes.get(i).comprat==1)
            {
               ++iTotal;
            }
        }
        return iTotal;
    }

    /**
     * Obté el total del preu dels elements a la llista
     * @return
     */
    public float getTotal()
    {
        float fTotal=0.0f;

        for(int i=0;i<liniallistes.size();i++)
        {
            fTotal+=liniallistes.get(i).preu;
        }
        return fTotal;
    }

    /**
     * Obté la suma del preu dels productes comprats
     * @return
     */
    public float getComprat()
    {
        float fComprat=0.0f;
        for(int i=0;i<liniallistes.size();i++)
        {
            if(liniallistes.get(i).comprat==1)
            {
                fComprat += liniallistes.get(i).preu;
            }
        }
        return fComprat;
    }

    @Override
    public int getCount()
    {
        return liniallistes.size();
    }

    @Override
    public Object getItem(int i)
    {
        return liniallistes.get(i);
    }

    @Override
    public long getItemId(int i)
    {
        return i;
    }

    @Override
    public View getView(int i, View view, ViewGroup viewGroup)
    {
        elementLlistaDetallView contenidor = null;
        if(view == null)
        {
            view = lInflater.inflate(R.layout.llista_detall_element, null);

            contenidor = new elementLlistaDetallView();
            contenidor.icnImatgeProducte = (ImageView) view.findViewById(R.id.ldetall_element_icnImatgeProducte);
            contenidor.txtNom = (TextView) view.findViewById(R.id.ldetall_element_txtNom);
            contenidor.txtPreu = (TextView) view.findViewById(R.id.ldetall_element_txtPreu);

            view.setTag(contenidor);
        } else
        {
            contenidor = (elementLlistaDetallView) view.getTag();
        }

        LiniaLlista liniaLlista = (LiniaLlista) getItem(i);
        if(null != liniaLlista)
        {
            contenidor.icnImatgeProducte.setImageResource(R.drawable.ic_content_picture); /// TODO: Afegir imatges!
            contenidor.txtNom.setText(liniaLlista.getProducte().nom);
            contenidor.txtPreu.setText(liniaLlista.preu + " €");
            if(liniaLlista.comprat==1)
            {
                contenidor.txtNom.setPaintFlags(contenidor.txtNom.getPaintFlags() | Paint.STRIKE_THRU_TEXT_FLAG);
            }
        }

        return view;
    }

    class elementLlistaDetallView
    {
        ImageView icnImatgeProducte;
        TextView txtNom;
        TextView txtPreu;
    }
}
