package com.olopezagu.smartlist.pantalles.LlistaProducteUtils;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.olopezagu.smartlist.R;
import com.olopezagu.smartlist.dades.Producte;

import java.util.ArrayList;

/**
 * Aquesta clase és la base de cada element del llistat de linies de compra de la aplicació.
 *
 *
 * Created by oscar on 17/05/14.
 */
public class elementLlistaProducteAdapter extends BaseAdapter
{
    private ArrayList<Producte> productes;
    private LayoutInflater lInflater;
    private boolean eventEsborra;

    public elementLlistaProducteAdapter(Context _ctx, ArrayList<Producte> _productes,boolean _eventEsborra)
    {
        this.lInflater= LayoutInflater.from(_ctx);
        this.productes=_productes;
        this.eventEsborra=_eventEsborra;
    }

    @Override
    public int getCount()
    {
        return productes.size();
    }

    @Override
    public Object getItem(int i)
    {
        return productes.get(i);
    }

    @Override
    public long getItemId(int i)
    {
        return i;
    }

    @Override
    public View getView(int i, View view, ViewGroup viewGroup)
    {
        elementLlistaProducteView contenidor = null;
        if(view == null)
        {
            view = lInflater.inflate(R.layout.llista_detall_element, null);

            contenidor = new elementLlistaProducteView();
            contenidor.icnImatgeProducte = (ImageView) view.findViewById(R.id.ldetall_element_icnImatgeProducte);
            contenidor.txtNom = (TextView) view.findViewById(R.id.ldetall_element_txtNom);
            contenidor.txtPreu = (TextView) view.findViewById(R.id.ldetall_element_txtPreu);

            view.setTag(contenidor);
        } else
        {
            contenidor = (elementLlistaProducteView) view.getTag();
        }

        Producte producte = (Producte) getItem(i);
        if(null != producte)
        {
            contenidor.icnImatgeProducte.setImageResource(R.drawable.ic_content_picture);
            contenidor.txtNom.setText(producte.nom);
            contenidor.txtPreu.setText(producte.preu + " €");
        }

        contenidor.txtNom.setClickable(eventEsborra);

        return view;
    }

    class elementLlistaProducteView
    {
        ImageView icnImatgeProducte;
        TextView txtNom;
        TextView txtPreu;
    }
}
