package com.olopezagu.smartlist.pantalles;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListAdapter;
import android.widget.ListView;

import com.olopezagu.smartlist.R;
import com.olopezagu.smartlist.dades.LiniaLlista;
import com.olopezagu.smartlist.dades.Llista;
import com.olopezagu.smartlist.pantalles.LlistesUtils.elementLlistaLlistesAdapter;
import com.olopezagu.smartlist.utils.PantallaSmartList;
import com.olopezagu.smartlist.utils.UsuariManager;
import com.olopezagu.smartlist.utils.Utils;
import com.olopezagu.smartlist.utils.finestraConfirmacioOnClick;

import java.util.ArrayList;



/**
 * Pantalla que mostra les llistes fetes
 *
 *
 * Created by oscar on 3/05/14.
 */
public class Llistes extends PantallaSmartList
{

    /**
     * Contingut de la llista
     */
    elementLlistaLlistesAdapter contingut;

    @Override
    protected void onInicialitza(Bundle _savedInstance)
    {
        ompleLlista();

        Llista.sincronitzaAmbServidor(new Handler()
        {
            @Override
            public void handleMessage(Message msg)
            {
                ompleLlista();
            }
        });

        setEventOnClickLlista();
    }

    @Override
    protected int getLayoutResourceId()
    {
        return R.layout.llistes;
    }


    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data)
    {
        super.onActivityResult(requestCode, resultCode, data);

        ompleLlista();


        Llista.sincronitzaAmbServidor(new Handler()
        {
            @Override
            public void handleMessage(Message msg)
            {
                ompleLlista();
            }
        });

    }

    /**
     * Omple la llista de elements en edició
     */
    private void ompleLlista()
    {
        ListView lstLlista = (ListView) findViewById(R.id.llistes_lstLlistat);
        ArrayList<Llista> llistes;

        llistes = (ArrayList) Llista.getLlistes(UsuariManager.getInstance().getIdUsuari());

        contingut = new elementLlistaLlistesAdapter(this, llistes);
        lstLlista.setAdapter(contingut);
        // Actualitza la llista
        lstLlista.setAdapter(lstLlista.getAdapter());
    }


    /**
     * Estableix els events de la llista al fer click
     */
    private void setEventOnClickLlista()
    {
        ListView lstLlista = (ListView) findViewById(R.id.llistes_lstLlistat);

        // OnClick a la llista
        lstLlista.setOnItemClickListener(new AdapterView.OnItemClickListener()
        {
            @Override
            public void onItemClick(AdapterView<?> adapterView, View view, int i, long l)
            {
                //Utils.missatgeContextual(getBaseContext(), "Seleccionat: " + i);
                ListAdapter la =(ListAdapter) adapterView.getAdapter();

                Llista tLlistaSeleccionada = (Llista)la.getItem(i);

                LiniaLlista.sincronitzaAmbServidor(tLlistaSeleccionada.idllista,null);

                Intent intent = new Intent(Llistes.this, LlistaDetall.class);
                intent.putExtra("accio", CODISLLISTA.ACTUALITZA_LLISTA);
                intent.putExtra("idllista",tLlistaSeleccionada.idllista);
                startActivityForResult(intent, CODISLLISTA.ACTUALITZA_LLISTA);
            }
        });

    }

    /**
     * Events de pantalla
     */


    public void btnAfegir_Click(View view)
    {
        Intent intent = new Intent(Llistes.this, LlistaDetall.class);
        intent.putExtra("accio", CODISLLISTA.NOVA_LLISTA);
        startActivityForResult(intent, CODISLLISTA.NOVA_LLISTA);
    }

    public void btnEsborra_Click(View view)
    {
        ListView lstLlista = (ListView) findViewById(R.id.llistes_lstLlistat);
        int iPosition = lstLlista.getPositionForView((View) view.getParent());
        Llista tLlista = (Llista) contingut.getItem(iPosition);
        //Utils.missatgeContextual(Utils.appContext, "Esborra: " + tLlista.nom);

        Utils.mostraConfirmacio(this, R.string.llista_esborra_titol, R.string.llista_esborra_missatge, new finestraConfirmacioOnClick(new Object[]{tLlista} ) {

            @Override
            public void click(DialogInterface dialogInterface, int i, Object[] parametres)
            {
                Llista tLlista = (Llista)parametres[0];

                tLlista.esborra();
                ompleLlista();
            }
        }, null);
    }

    /**
     * Llista de possibles codis per enviar
     */
    public static class CODISLLISTA
    {
        public static int ERROR=0x0;
        public static int NOVA_LLISTA=0x1;
        public static int ACTUALITZA_LLISTA=0x2;
    }
}
