package com.olopezagu.smartlist.pantalles.LlistesUtils;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewParent;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.olopezagu.smartlist.R;
import com.olopezagu.smartlist.dades.Llista;
import com.olopezagu.smartlist.utils.Utils;

import java.util.ArrayList;

/**
 *
 * Aquesta clase és la base de cada element del llistat de llistes de compra de la aplicació.
 *
 *
 * Created by oscar on 17/05/14.
 */
public class elementLlistaLlistesAdapter extends BaseAdapter
{
    private ArrayList<Llista> llistatLlistes;
    private LayoutInflater lInflater;

    public elementLlistaLlistesAdapter(Context _ctx, ArrayList<Llista> _llistatLlistes)
    {
        this.lInflater= LayoutInflater.from(_ctx);
        this.llistatLlistes=_llistatLlistes;
    }

    @Override
    public int getCount()
    {
        return llistatLlistes.size();
    }

    @Override
    public Object getItem(int i)
    {
        return llistatLlistes.get(i);
    }

    @Override
    public long getItemId(int i)
    {
        return i;
    }

    @Override
    public View getView(int i, View view, ViewGroup viewGroup)
    {
        elementLlistaView contenidor = null;
        if(view == null)
        {
            view = lInflater.inflate(R.layout.llistes_element, null);

            contenidor = new elementLlistaView();
            contenidor.icnEstat = (ImageView) view.findViewById(R.id.llistes_element_icnEstat);
            contenidor.txtNom = (TextView) view.findViewById(R.id.llistes_element_txtNom);
            contenidor.icnUsuaris = (ImageView) view.findViewById(R.id.llistes_element_icnUsuaris);
            contenidor.icnEsborra = (ImageView) view.findViewById(R.id.llistes_element_esborra);

            view.setTag(contenidor);
        } else
        {
            contenidor = (elementLlistaView) view.getTag();
        }
        Llista llista = (Llista) getItem(i);
        contenidor.icnEstat.setImageResource(R.drawable.ic_editar);
        contenidor.txtNom.setText(llista.nom);
        contenidor.icnUsuaris.setImageResource(R.drawable.ic_social_group);
        contenidor.icnEsborra.setImageResource(R.drawable.ic_content_remove);


        return view;
    }

    class elementLlistaView
    {
        ImageView icnEstat;
        TextView txtNom;
        ImageView icnUsuaris;
        ImageView icnEsborra;
    }
}
