/**
 *
 */
package com.olopezagu.smartlist.pantalles;

import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.widget.GridView;
import android.widget.ImageView;
import android.widget.TextView;

import com.olopezagu.smartlist.R;
import com.olopezagu.smartlist.utils.PantallaSmartList;
import com.olopezagu.smartlist.utils.UsuariManager;
import com.olopezagu.smartlist.utils.Utils;

/**
 * Menú principal de la aplicació
 *
 *
 * @author oscar
 */
public class Menu extends PantallaSmartList {

    GridView gridView;

    @Override
    protected void onInicialitza(Bundle _savedInstance) {

        TextView btnLlistes = (TextView) findViewById(R.id.menu_llistes);
        TextView btnProductes = (TextView) findViewById(R.id.menu_productes);
        TextView btnEstadistiques = (TextView) findViewById(R.id.menu_estadistiques);
        TextView btnNotificacions = (TextView) findViewById(R.id.menu_notificacions);
        ImageView btnRegistreUsuari = (ImageView) findViewById(R.id.menu_registreUsuari);


        // Events per poder assignar funcions als butons
        btnLlistes.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(Menu.this, Llistes.class);
                startActivity(intent);
            }
        });

        btnProductes.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(Menu.this, Productes.class);
                startActivity(intent);
            }
        });

        btnEstadistiques.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(Menu.this, Estadistiques.class);
                startActivity(intent);
            }
        });

        btnNotificacions.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(Menu.this, Notificacions.class);
                startActivity(intent);
            }
        });

        btnRegistreUsuari.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(Menu.this, RegistreUsuari.class);
                startActivity(intent);
            }
        });

        UsuariManager.comprovaLoginUsuari(false,null, new Handler()
        {
            @Override
            public void handleMessage(Message msg)
            {
                Utils.missatgeContextual(getApplicationContext(),R.string.missatge_no_login);
            }
        });
    }

    @Override
    protected int getLayoutResourceId()
    {
        return R.layout.menu_principal;
    }
}
