package com.olopezagu.smartlist.pantalles;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;

import com.olopezagu.smartlist.R;
import com.olopezagu.smartlist.dades.LiniaLlista;
import com.olopezagu.smartlist.dades.Producte;
import com.olopezagu.smartlist.utils.PantallaSmartList;
import com.olopezagu.smartlist.utils.UsuariManager;
import com.olopezagu.smartlist.utils.Utils;
import com.olopezagu.smartlist.utils.finestraConfirmacioOnClick;

import com.google.zxing.integration.android.IntentIntegrator;
import com.google.zxing.integration.android.IntentResult;


import java.util.Date;

/**
 * Pantalla de la creació del nou producte de la aplicació
 *
 *
 * Created by oscar on 17/05/14.
 */
public class NouProducte extends PantallaSmartList
{
    /**
     * Producte amb el que treballem a la pantalla
     */
    Producte producte;
    int accio;
    LiniaLlista liniaLlista;
    String idLlista;

    @Override
    protected void onInicialitza(Bundle _savedInstance)
    {
        Bundle parametresRebuts = getIntent().getExtras();

        UsuariManager.getInstance().comprovaLoginUsuari(true, null, null);


        accio = parametresRebuts.getInt("accio");
        idLlista = parametresRebuts.getString("idllista");


        if(accio == LlistaDetall.CODISLLISTADETALLS.NOU_PRODUCTE || accio == LlistaDetall.CODISLLISTADETALLS.NOU_PRODUCTE_LLISTA)
        {
            producte = new Producte();

            if(accio == LlistaDetall.CODISLLISTADETALLS.NOU_PRODUCTE_LLISTA)
            {
                liniaLlista = new LiniaLlista();
                liniaLlista.quantitat = 1;
            }
        } else
        {
            String idproducte = parametresRebuts.getString("idproducte");
            ((TextView) findViewById(R.id.nou_producte_titol)).setText(R.string.noup_edita_producte);
            producte = Producte.getProducte(idproducte);
            if(producte == null)
            {
                producte = new Producte();
            }
        }

        if(accio == LlistaDetall.CODISLLISTADETALLS.ACTUALITZA_PRODUCTE_LLISTA)
        {
            liniaLlista = LiniaLlista.getLiniaLlista(parametresRebuts.getString("idliniallista"));
        }

        if(accio != LlistaDetall.CODISLLISTADETALLS.ACTUALITZA_PRODUCTE_LLISTA && accio !=LlistaDetall.CODISLLISTADETALLS.NOU_PRODUCTE_LLISTA )
        {
            ((ImageView) findViewById(R.id.noup_btnBorra)).setVisibility(View.INVISIBLE);
            TableRow row =   (TableRow) findViewById(R.id.noup_tblQuantitat);
            TableLayout table = (TableLayout) findViewById(R.id.noup_tblTaula);
            table.removeView(row);
        }

        omplePantalla();
    }

    /*
     * Omple la pantalla de producte amb les dades conegudes del producte, si nhi ha
     */
    private void omplePantalla()
    {
        ((EditText) findViewById(R.id.noup_txtNomProducte)).setText(producte.nom);
        ((EditText) findViewById(R.id.noup_txtPreuUnitat)).setText(Float.toString(producte.preu));
        ((EditText) findViewById(R.id.noup_txtCodiBarres)).setText(producte.codibarres);
        if(liniaLlista != null)
        {
            ((EditText) findViewById(R.id.noup_txtQuantitat)).setText(Integer.toString(liniaLlista.quantitat));
        }
    }

    /**
     * Chequeja i guarda les dades de la aplicació
     */
    private void guardaDades()
    {
        String tCamp;

        producte.nom = ((EditText) findViewById(R.id.noup_txtNomProducte)).getText().toString();
        tCamp = ((EditText) findViewById(R.id.noup_txtPreuUnitat)).getText().toString();
        if(tCamp == null || tCamp == "") tCamp = "0";
        producte.preu = Float.parseFloat(tCamp);
        producte.codibarres = ((EditText) findViewById(R.id.noup_txtCodiBarres)).getText().toString();

        producte.guarda();

        afegeixProducteLlista();
    }

    @Override
    protected int getLayoutResourceId()
    {
        return R.layout.nou_producte;
    }

    /**
     * Afegeix un el producte a la llista
     */
    private void afegeixProducteLlista()
    {
        if(liniaLlista!=null)
        {
            liniaLlista.idllista = idLlista;
            liniaLlista.quantitat= Integer.parseInt(((EditText) findViewById(R.id.noup_txtQuantitat)).getText().toString());
            liniaLlista.preu = producte.preu;
            liniaLlista.datacompra = new Date();
            liniaLlista.idusuariassignat = UsuariManager.getInstance().getIdUsuari();
            liniaLlista.setProducte( producte);
            liniaLlista.idProducte=producte.idproducte;
            liniaLlista.guarda();
        }
    }


    /// EVENTS DE BOTONS

    /**
     * Event del botó per escanejar un producte
     * @param view
     */
    public void btnScan_Click(View view)
    {
        IntentIntegrator scanIntegrator = new IntentIntegrator(this);
        scanIntegrator.initiateScan();
    }

    /**
     * Event del botó per guardar el producte
     * @param view
     */
    public void btnAcceptar_Click(View view)
    {
        guardaDades();

        Intent intent = new Intent();
        intent.putExtra("idproducte", producte.idproducte);
        setResult(accio);

        this.finish();
    }

    /**
     * Event del botó per esborrar el producte
     * @param view
     */
    public void btnBorra_Click(View view)
    {
        if(producte.idproducte != null || producte.idproducte != "")
        {
            Utils.mostraConfirmacio(this, R.string.noup_borra_titol, R.string.noup_borra_missatge, new finestraConfirmacioOnClick(null) {
                @Override
                public void click(DialogInterface dialogInterface, int i, Object[] parametres)
                {
                    liniaLlista.esborra();
                    Log.w("Info - ", getApplicationContext().getResources().getString(R.string.liniallista_esborrada));
                    btnCancela_Click(null);
                }
            }, null);
        }
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent intent) {

        // Codi per tractar la informació rebuda al escanejar el producte
        IntentResult scanningResult = IntentIntegrator.parseActivityResult(requestCode, resultCode, intent);
        if (scanningResult != null) {
            ((EditText) findViewById(R.id.noup_txtCodiBarres)).setText(scanningResult.getContents());
        }
    }

}
