package com.olopezagu.smartlist.pantalles;

import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListAdapter;
import android.widget.ListView;

import com.olopezagu.smartlist.R;
import com.olopezagu.smartlist.dades.LiniaLlista;
import com.olopezagu.smartlist.dades.Producte;
import com.olopezagu.smartlist.pantalles.LlistaDetallUtils.elementLlistaDetallAdapter;
import com.olopezagu.smartlist.pantalles.LlistaProducteUtils.elementLlistaProducteAdapter;
import com.olopezagu.smartlist.pantalles.LlistesUtils.elementLlistaLlistesAdapter;
import com.olopezagu.smartlist.utils.PantallaSmartList;
import com.olopezagu.smartlist.utils.UsuariManager;
import com.olopezagu.smartlist.utils.Utils;

import java.util.ArrayList;
import java.util.Date;
import java.util.UUID;

/**
 * Pantalla de productes
 *
 *
 * Created by oscar on 3/05/14.
 */
public class Productes extends PantallaSmartList
{
    int accio;
    String idllista;

    @Override
    protected void onInicialitza(Bundle _savedInstance)
    {
        ompleLlista();
        Producte.sincronitzaAmbServidor(new Handler()
        {
            @Override
            public void handleMessage(Message msg)
            {
                ompleLlista();
            }
        });

        Bundle parametresRebuts = getIntent().getExtras();
        if(parametresRebuts != null && parametresRebuts.containsKey("accio"))
        {
            accio = parametresRebuts.getInt("accio");
            idllista = parametresRebuts.getString("idllista");
        }
        setEventOnClickLlista();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data)
    {
        super.onActivityResult(requestCode, resultCode, data);
        if(accio== LlistaDetall.CODISLLISTADETALLS.INSERTA_PRODUCTE_EXISTENT)
        {
            finish();
        }else
        {
            ompleLlista();
        }
    }


    @Override
    protected int getLayoutResourceId()
    {
        return  R.layout.llistat_productes;
    }

    /**
     * Omple la llista de elements en edició
     */
    private void ompleLlista()
    {
        ListView lstLlista = (ListView) findViewById(R.id.prod_lstproductes);
        ArrayList<Producte> llistes;

        llistes = (ArrayList) Producte.getProductes(UsuariManager.getInstance().getIdUsuari());

        elementLlistaProducteAdapter contingut = new elementLlistaProducteAdapter(this, llistes,false);
        lstLlista.setAdapter(contingut);
        // Actualitza la llista
        lstLlista.setAdapter(lstLlista.getAdapter());
    }


    /**
     * Estableix els events de la llista al fer click
     */
    private void setEventOnClickLlista()
    {
        ListView lstLlista = (ListView) findViewById(R.id.prod_lstproductes);

        // OnClick a la llista
        lstLlista.setOnItemClickListener(new AdapterView.OnItemClickListener()
        {
            @Override
            public void onItemClick(AdapterView<?> adapterView, View view, int i, long l)
            {
                //Utils.missatgeContextual(getBaseContext(), "Seleccionat: " + i);
                ListAdapter la =(ListAdapter) adapterView.getAdapter();
                Intent intent = new Intent(Productes.this, NouProducte.class);

                Producte tProducte = (Producte)la.getItem(i);
                if(accio== LlistaDetall.CODISLLISTADETALLS.INSERTA_PRODUCTE_EXISTENT)
                {
                    LiniaLlista tLiniaLlista = new LiniaLlista();
                    tLiniaLlista.idliniallista = UUID.randomUUID().toString().toUpperCase();
                    tLiniaLlista.idllista=idllista;
                    tLiniaLlista.idProducte = tProducte.idproducte;
                    tLiniaLlista.setProducte(tProducte);
                    tLiniaLlista.quantitat=1;
                    tLiniaLlista.datacompra=Utils.dataNull();
                    tLiniaLlista.idusuariassignat= UsuariManager.getInstance().getIdUsuari();
                    tLiniaLlista.save();


                    intent.putExtra("accio", LlistaDetall.CODISLLISTADETALLS.ACTUALITZA_PRODUCTE_LLISTA);
                    intent.putExtra("idllista", idllista);
                    intent.putExtra("idliniallista",tLiniaLlista.idliniallista);
                    intent.putExtra("idproducte",tLiniaLlista.getProducte().idproducte);
                    startActivityForResult(intent, LlistaDetall.CODISLLISTADETALLS.ACTUALITZA_PRODUCTE_LLISTA);
                }
                else
                {
                    intent.putExtra("accio", LlistaDetall.CODISLLISTADETALLS.ACTUALITZA_PRODUCTE);
                    intent.putExtra("idproducte", tProducte.idproducte);
                    startActivityForResult(intent, LlistaDetall.CODISLLISTADETALLS.ACTUALITZA_PRODUCTE);
                }

            }
        });
    }
}
