package com.olopezagu.smartlist.pantalles;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.view.Window;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.TextView;

import com.olopezagu.smartlist.R;
import com.olopezagu.smartlist.dades.Amic;
import com.olopezagu.smartlist.dades.Llista;
import com.olopezagu.smartlist.dades.Usuari;
import com.olopezagu.smartlist.utils.PantallaSmartList;
import com.olopezagu.smartlist.utils.RestManager;
import com.olopezagu.smartlist.utils.RestManagerUtils.ErrorHandler;
import com.olopezagu.smartlist.utils.RestManagerUtils.PropietatsCua;
import com.olopezagu.smartlist.utils.UsuariManager;
import com.olopezagu.smartlist.utils.Utils;

import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by oscar on 3/05/14.
 */
public class RegistreUsuari extends PantallaSmartList
{
    Usuari usuari;

    /*
     * Events dels botons de la pantalla
     */

    public void btnFoto_Click(View target)
    {
        Intent intent = new Intent(Intent.ACTION_PICK);
        intent.setType("image/*");

        startActivityForResult(intent, 0);
    }

    public void rbtnRegistre_Click(View target)
    {
        ((TextView) findViewById(R.id.lblRContrasenya)).setVisibility(View.VISIBLE);
        ((TextView) findViewById(R.id.txtRContrasenya)).setVisibility(View.VISIBLE);
    }

    public void rbtnLogin_Click(View target)
    {
        ((TextView) findViewById(R.id.lblRContrasenya)).setVisibility(View.INVISIBLE);
        ((TextView) findViewById(R.id.txtRContrasenya)).setVisibility(View.INVISIBLE);
    }

    @Override
    protected void onInicialitza(Bundle _savedInstance)
    {
        Usuari tUsuari = UsuariManager.getInstance().getUsuari();

        if(tUsuari != null)
        {
            ((EditText) findViewById(R.id.txtNom)).setText(tUsuari.nom);
            ((EditText) findViewById(R.id.txtEmail)).setText(tUsuari.email);
        }
    }

    @Override
    protected int getLayoutResourceId()
    {
        return R.layout.registre_usuari;
    }

    public void btnCancela_Click(View target)
    {
        this.finish();
    }

    public void btnAccepta_Click(View target)
    {
        String nom = ((EditText) findViewById(R.id.txtNom)).getText().toString();
        String email = ((EditText) findViewById(R.id.txtEmail)).getText().toString();
        String contrasenya = ((EditText) findViewById(R.id.txtContrasenya)).getText().toString();
        String contrasenya_r = ((EditText) findViewById(R.id.txtRContrasenya)).getText().toString();


        // Si hi ha algun error amb les contrasenyes, torna
        if(!checkContrasenyes(contrasenya, contrasenya_r, false))
        {
            return;
        }

        ((EditText) findViewById(R.id.txtNom)).setEnabled(false);
        ((EditText) findViewById(R.id.txtEmail)).setEnabled(false);
        ((EditText) findViewById(R.id.txtContrasenya)).setEnabled(false);
        ((EditText) findViewById(R.id.txtRContrasenya)).setEnabled(false);

        List<NameValuePair> ops = new ArrayList<NameValuePair>();

        boolean esRegistre = ((RadioButton) findViewById(R.id.rbtnRegistre)).isChecked();

        if(esRegistre)
        {
            ops.add(new BasicNameValuePair("nom", nom));
        }
        ops.add(new BasicNameValuePair("email", email));
        ops.add(new BasicNameValuePair("password", contrasenya));


        String sAccio = (esRegistre) ? "registre" : "login";
        Usuari tUsuari = new Usuari();

        tUsuari.nom=nom;
        tUsuari.email=email;
        tUsuari.password=contrasenya;

        if(esRegistre)
        {
           UsuariManager.registraUsuari(tUsuari,true, new Handler(){
            @Override
            public void handleMessage(Message msg)
            {
                ((EditText) findViewById(R.id.txtNom)).setEnabled(true);
                ((EditText) findViewById(R.id.txtEmail)).setEnabled(true);
                ((EditText) findViewById(R.id.txtContrasenya)).setEnabled(true);
                ((EditText) findViewById(R.id.txtRContrasenya)).setEnabled(true);
                Utils.missatgeContextual(getApplicationContext(),  R.string.missatge_registre_ok);

                Amic.sincronitzaAmbServidor(null);

                btnCancela_Click(null);
            }
           },new Handler(){
               @Override
               public void handleMessage(Message msg)
               {
                   ((EditText) findViewById(R.id.txtNom)).setEnabled(true);
                   ((EditText) findViewById(R.id.txtEmail)).setEnabled(true);
                   ((EditText) findViewById(R.id.txtContrasenya)).setEnabled(true);
                   ((EditText) findViewById(R.id.txtRContrasenya)).setEnabled(true);

                   Utils.missatgeContextual(getApplicationContext(),  R.string.missatge_registre_error);
               }
           });
        }
        else
        {
            UsuariManager.comprovaLoginUsuari(tUsuari,true, new Handler(){
                @Override
                public void handleMessage(Message msg)
                {
                    ((EditText) findViewById(R.id.txtNom)).setEnabled(true);
                    ((EditText) findViewById(R.id.txtEmail)).setEnabled(true);
                    ((EditText) findViewById(R.id.txtContrasenya)).setEnabled(true);
                    ((EditText) findViewById(R.id.txtRContrasenya)).setEnabled(true);
                    Utils.missatgeContextual(getApplicationContext(),  R.string.missatge_login_ok);

                    Amic.sincronitzaAmbServidor(null);

                    btnCancela_Click(null);
                }
            },new Handler(){
                @Override
                public void handleMessage(Message msg)
                {
                    ((EditText) findViewById(R.id.txtNom)).setEnabled(true);
                    ((EditText) findViewById(R.id.txtEmail)).setEnabled(true);
                    ((EditText) findViewById(R.id.txtContrasenya)).setEnabled(true);
                    ((EditText) findViewById(R.id.txtRContrasenya)).setEnabled(true);
                    Utils.missatgeContextual(getApplicationContext(),  R.string.missatge_login_error);
                }
            });
        }
    }

    /**
     * Fa les comprovacions pertinents de les contrasenyes
     *
     * @param contrasenya
     * @param contrasenya_r
     * @return
     */
    private boolean checkContrasenyes(String contrasenya, String contrasenya_r, boolean _esRegistre)
    {
        if(_esRegistre && !contrasenya.equals(contrasenya_r))
        {
            Utils.missatgeContextual(getApplicationContext(), R.string.missatge_contrasenyes_no_coincideixen);
            return false;
        }

        if(contrasenya.length() < 4)
        {
            Utils.missatgeContextual(getApplicationContext(), R.string.missatge_contrasenya_massa_curta);
            return false;
        }

        return true;

    }
}




