package com.olopezagu.smartlist.utils;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Toast;

import com.olopezagu.smartlist.dades.Usuari;

import java.util.List;

/**
 * Classe abstracta derivada de Activity que serveix per implementar funcionalitats extres a la resta de pantalles
 *
 *
 * Created by oscar on 13/05/14.
 */
public abstract class PantallaSmartList extends Activity
{

    protected Usuari usuariActiu = null;
    private boolean isUsuariLogin = false;

    /**
     * Classe que s'executa després del intent de fer login
     *
     * @param _savedInstance
     */
    protected abstract void onInicialitza(Bundle _savedInstance);

    /**
     * Métode abstract que rep la pantalla que ha de dibuixar
     * @return la ID de la pantalla a dibuixar
     */
    protected abstract int getLayoutResourceId();

    /**
     * Implementació estándart del event de tancar activitat
     * @param target
     */
    public void btnCancela_Click(View target)
    {
        this.finish();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        //Esborra la barra del títol
        //this.requestWindowFeature(Window.FEATURE_NO_TITLE);


        Utils.appContext = getApplication();
        Utils.thisContext = this;

        setContentView(getLayoutResourceId());
        onInicialitza(savedInstanceState);
    }
}

