<?php

require_once __DIR__ . '/DBUtils.php';
/*
 * Clase per gestionar les opcions relacionades amb la linia de la llista
 * 
 */

class gestioEstadistiques
{

    /**
     * Obté les estadistiques de la BBDD
     * 
     * @param \Slim\Slim $app APP en execució
     */
    public static function estadistiques(\Slim\Slim $app)
    {
        DBUtils::configuraBD();

        $app->get('/estadistica', 'gestioUsuari::comprovaConnexio', function() use ($app) {

            $idusuari = $app->request()->get("idusuari");
            $datainici = $app->request()->get("datainici");
            $datafi = $app->request()->get("datafi");

            $resultat['compres_fetes'] = R::getRow("SELECT count(preu) AS preu FROM smartlist.liniallista WHERE comprat=1 AND idusuariassignat= :idusuari AND datacompra BETWEEN :datainici AND :datafi;", [":idusuari" => $idusuari,":datainici"=>$datainici,":datafi"=>$datafi]);
            $resultat['producte_mes_consumit'] = R::getRow("SELECT nom,sum(1) AS sumatori FROM smartlist.producte, smartlist.liniallista WHERE smartlist.producte.idproducte = smartlist.liniallista.idproducte AND smartlist.liniallista.idusuariassignat= :idusuari AND smartlist.liniallista.datacompra BETWEEN :datainici AND :datafi GROUP BY producte.nom ORDER BY sumatori DESC LIMIT 1;", [":idusuari" => $idusuari,":datainici"=>$datainici,":datafi"=>$datafi]);
            $resultat['compra_major_import'] = R::getRow("SELECT distinct(l.nom), sum(li.preu) AS preu FROM smartlist.llista AS l, smartlist.liniallista AS li WHERE l.idllista = li.idllista AND l.idusuari = :idusuari AND l.datacreacio BETWEEN :datainici AND :datafi GROUP BY l.idllista ORDER BY preu DESC LIMIT 1;", [":idusuari" => $idusuari,":datainici"=>$datainici,":datafi"=>$datafi]);
            $resultat['compra_menor_import'] = R::getRow("SELECT distinct(l.nom), sum(li.preu) AS preu FROM smartlist.llista AS l, smartlist.liniallista AS li WHERE l.idllista = li.idllista AND l.idusuari = :idusuari AND l.datacreacio BETWEEN :datainici AND :datafi GROUP BY l.idllista ORDER BY preu LIMIT 1;", [":idusuari" => $idusuari,":datainici"=>$datainici,":datafi"=>$datafi]);
            $resultat['total_periode'] = R::getRow("SELECT sum(li.preu) AS total FROM smartlist.liniallista AS li, smartlist.llista AS l WHERE li.idusuariassignat= :idusuari AND li.idllista= l.idllista AND l.datacreacio BETWEEN :datainici AND :datafi;", [":idusuari" => $idusuari,":datainici"=>$datainici,":datafi"=>$datafi]);

            enviaResposta(200, $resultat);
        });
    }

 
}
